## openfec 1.4.2.9+dfsg

=== CMakeLists.txt ===
if(CMAKE_MAJOR_VERSION LESS 3)
  cmake_minimum_required(VERSION 2.6)
else()
  cmake_minimum_required(VERSION 2.8.12)
endif()

##project
project(openfec C)
include(GNUInstallDirs)

file(READ ${PROJECT_SOURCE_DIR}/.version VERSION_TAG)
string(REGEX REPLACE "\n$" "" VERSION_TAG "${VERSION_TAG}")
message(STATUS "Project version: ${VERSION_TAG}")

set(PROJECT_VERSION "${VERSION_TAG}")
set(PROJECT_DESCRIPTION "Application-Level Forward Erasure Correction implementation library")

ENABLE_TESTING()

if (PROFILING STREQUAL "ON")

else(PROFILING STREQUAL "ON")

endif(PROFILING STREQUAL "ON")

if (DEBUG STREQUAL "ON")
# Debug mode
ADD_DEFINITIONS(-DOF_DEBUG)
set(CMAKE_BUILD_TYPE Debug)
message(STATUS "Debug mode ON" )

else(DEBUG STREQUAL "ON")
# Release mode
set(CMAKE_BUILD_TYPE Release)
set(OPTIMIZE "3" CACHE STRING "Set optimization level (0-3 or DEFAULT)")
if (NOT OPTIMIZE STREQUAL "DEFAULT")
  string(REGEX REPLACE "(-O[A-Za-z0-9]+)" "" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
  string(REGEX REPLACE "(-O[A-Za-z0-9]+)" "" CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
  set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O${OPTIMIZE}")
endif()
message(STATUS "Debug mode OFF")
message(STATUS "Optimization level ${OPTIMIZE}")

endif (DEBUG STREQUAL "ON")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")

set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/bin/${CMAKE_BUILD_TYPE}
  CACHE STRING "output path for libraries")
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/bin/${CMAKE_BUILD_TYPE}
  CACHE STRING "output path for executables")
MARK_AS_ADVANCED(
        LIBRARY_OUTPUT_PATH
        EXECUTABLE_OUTPUT_PATH
)

option(INSTALL_DEVTOOLS "install developer tools to the system" OFF)

link_directories(${LIBRARY_OUTPUT_PATH})

add_subdirectory(pc)
add_subdirectory(src)
add_subdirectory(applis/eperftool)
add_subdirectory(applis/howto_examples/simple_client_server)
add_subdirectory(tools/descr_stats_v1.2)
add_subdirectory(tests)

=== pc/CMakeLists.txt ===
include(GNUInstallDirs)

SET(PKG_CONFIG_LIBS
    "-L\${libdir} -l${PROJECT_NAME}"
)
SET(PKG_CONFIG_CFLAGS
    "-I\${includedir}/lib_common -I\${includedir}/lib_stable -I\${includedir}/lib_advanced"
)

message(STATUS "Configuring \"${CMAKE_SOURCE_BINARY_DIR}/${PROJECT_NAME}.pc\"")

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.pc.in"
  "${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.pc"
  @ONLY
)

install(
    FILES "${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.pc"
    DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/pkgconfig)

=== src/CMakeLists.txt ===
file (GLOB_RECURSE openfec_sources *)

# Use -DBUILD_STATIC_LIBS=ON to build static libraries instead of shared.
option(BUILD_STATIC_LIBS "Build the static library" OFF)

if(BUILD_STATIC_LIBS)
  add_library(openfec STATIC ${openfec_sources})
else(BUILD_STATIC_LIBS)
  add_library(openfec SHARED ${openfec_sources})
endif(BUILD_STATIC_LIBS)

# From: $cmake --help-property SOVERSION
#		For shared libraries VERSION and SOVERSION can be used to specify
#		the build version and api version respectively.
#
# Edit it as appropriate to be in line with the src/lib_common/of_openfec_api.c::more_about() version
#
set_target_properties(openfec PROPERTIES
			VERSION 1.4.2
			SOVERSION 1) 

# Feel free to edit as appropriate the "target_link_libraries".
#
# Add the IL (DevIL) library if you want to have the possibility to
# produce H/G matrix images with LDPC codes.
# More precisely, we are relying on the DevIL library
# (http://openil.sourceforge.net/).
# Please install it on your machine before compiling the OpenFEC
# library if needed.
# Otherwise remove the IL library.

target_link_libraries(openfec m)
#target_link_libraries(openfec m IL)

#target_link_libraries(openfec pthread IL)
#target_link_libraries(openfec pthread)

install(TARGETS openfec DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})

install(
    DIRECTORY ${PROJECT_SOURCE_DIR}/src/
    DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/openfec
    FILES_MATCHING PATTERN "*.h*")

include(TestBigEndian)
test_big_endian(BIG_ENDIAN)
if(BIG_ENDIAN)
  target_compile_definitions(openfec PRIVATE OPENFEC_BIG_ENDIAN)
else(BIG_ENDIAN)
  target_compile_definitions(openfec PRIVATE OPENFEC_LITTLE_ENDIAN)
endif(BIG_ENDIAN)

=== tests/CMakeLists.txt ===
# list of dedicated binary tests
add_executable(test_create_instance create_instance_test.c)
target_link_libraries(test_create_instance openfec m)
add_test("create_instance" ${EXECUTABLE_OUTPUT_PATH}/test_create_instance)
set_tests_properties ("create_instance"
	PROPERTIES FAIL_REGULAR_EXPRESSION "ERROR;FAILURE")

add_executable(test_encoder_instance encoder_instance_test.c)
target_link_libraries(test_encoder_instance openfec m)
add_test("encoder_instance" ${EXECUTABLE_OUTPUT_PATH}/test_encoder_instance)
set_tests_properties ("encoder_instance"
	PROPERTIES FAIL_REGULAR_EXPRESSION "ERROR;FAILURE")

add_executable(test_code_params code_params_test.c)
target_link_libraries(test_code_params openfec m)
add_test("code_params" ${EXECUTABLE_OUTPUT_PATH}/test_code_params)
set_tests_properties ("code_params"
	PROPERTIES FAIL_REGULAR_EXPRESSION "ERROR;FAILURE")


# definition of the do_test macro used below
macro (do_test name)
    add_test(Test.${name} ${EPERFTOOL_BIN} ${ARGN})
    set_tests_properties (Test.${name}
        PROPERTIES FAIL_REGULAR_EXPRESSION "ERROR;FAILURE")
endmacro(do_test)


# list of automatic tests using eperftool. Add your own tests here...

#
# PART 1: LDPC-Staircase tests
#

# Robustness in front of many transmission types
#
do_test(LDPC-SC-ADV.cr2.3.tx0 	 -codec=3 -seed=1 -tot_src=1000 -tot_rep=500)
do_test(LDPC-SC-ADV.cr1.2.tx1 	 -codec=3 -seed=1 -tot_src=1000 -tot_rep=1000 -tx_type=1)
do_test(LDPC-SC-ADV.cr1.2.tx2 	 -codec=3 -seed=1 -tot_src=1000 -tot_rep=1000 -tx_type=2)
do_test(LDPC-SC.cr1.2.tx3   	 -codec=3 -seed=1 -tot_src=1000 -tot_rep=1090 -tx_type=3)
do_test(LDPC-SC.cr2.3.tx4   	 -codec=3 -seed=1 -tot_src=1000 -tot_rep=500 -tx_type=4)
do_test(LDPC-SC.cr2.3.tx5   	 -codec=3 -seed=1 -tot_src=1000 -tot_rep=500 -tx_type=5)
do_test(LDPC-SC.cr2.3.tx6   	 -codec=3 -seed=1 -tot_src=1000 -tot_rep=500 -tx_type=6)
do_test(LDPC-SC.cr2.3.tx7   	 -codec=3 -seed=1 -tot_src=1000 -tot_rep=500 -tx_type=7)
do_test(LDPC-SC.cr2.3.loss1 	 -codec=3 -seed=1 -tot_src=1000 -tot_rep=500 -loss=2:30)
do_test(LDPC-SC.cr2.3.loss2 	 -codec=3 -seed=1 -tot_src=1000 -tot_rep=500 -loss=3:480)
do_test(LDPC-SC.cr2.3.loss3 	 -codec=3 -seed=1 -tot_src=1000 -tot_rep=500 -loss=1)
do_test(LDPC-SC.cr1.2.loss4 	 -codec=3 -seed=1 -tot_src=1000 -tot_rep=1000 -loss=4)
do_test(LDPC-SC.cr3.4.tx4   	 -codec=3 -seed=1 -tot_src=1500 -tot_rep=500 -tx_type=4)
do_test(LDPC-SC.cr3.4.tx5   	 -codec=3 -seed=1 -tot_src=1500 -tot_rep=500 -tx_type=5)
do_test(LDPC-SC.cr3.4.tx6   	 -codec=3 -seed=1 -tot_src=1500 -tot_rep=500 -tx_type=6)
do_test(LDPC-SC.cr3.4.tx7   	 -codec=3 -seed=1 -tot_src=1500 -tot_rep=500 -tx_type=7)
do_test(LDPC-SC.cr3.4.loss1 	 -codec=3 -seed=1 -tot_src=1500 -tot_rep=500 -loss=2:24)
do_test(LDPC-SC.cr3.4.loss2 	 -codec=3 -seed=1 -tot_src=1500 -tot_rep=500 -loss=3:480)
do_test(LDPC-SC.cr3.4.loss3 	 -codec=3 -seed=1 -tot_src=1500 -tot_rep=500 -loss=1)
do_test(LDPC-SC.cr3.4.loss4 	 -codec=3 -seed=1 -tot_src=1500 -tot_rep=1000 -loss=4)

# IT decoding tests
#
do_test(LDPC-SC.cr2.3.small.IT   	 -codec=3 -seed=1 -tot_src=100 -tot_rep=50)
do_test(LDPC-SC.cr1.2.small.IT   	 -codec=3 -seed=1 -tot_src=100 -tot_rep=100)
do_test(LDPC-SC.cr1.3.small.IT   	 -codec=3 -seed=1 -tot_src=100 -tot_rep=200)
do_test(LDPC-SC.cr1.4.small.IT   	 -codec=3 -seed=1 -tot_src=100 -tot_rep=300)
do_test(LDPC-SC.cr1.5.small.IT   	 -codec=3 -seed=1 -tot_src=100 -tot_rep=400)

do_test(LDPC-SC.cr3.4.med.IT   	 -codec=3 -seed=1 -tot_src=1000 -tot_rep=500)
do_test(LDPC-SC.cr1.2.med.IT   	 -codec=3 -seed=1 -tot_src=1000 -tot_rep=1000)
do_test(LDPC-SC.cr1.3.med.IT   	 -codec=3 -seed=1 -tot_src=1000 -tot_rep=2000)

do_test(LDPC-SC.src1.IT  	 -codec=3 -seed=1 -tot_src=1  -tot_rep=23)
do_test(LDPC-SC.src2.IT  	 -codec=3 -seed=1 -tot_src=2  -tot_rep=23)
do_test(LDPC-SC.src3.IT  	 -codec=3 -seed=1 -tot_src=3  -tot_rep=23)
do_test(LDPC-SC.src4.IT  	 -codec=3 -seed=1 -tot_src=4  -tot_rep=23)
do_test(LDPC-SC.src5.IT  	 -codec=3 -seed=1 -tot_src=5  -tot_rep=23)
do_test(LDPC-SC.src6.IT  	 -codec=3 -seed=1 -tot_src=6  -tot_rep=23)
do_test(LDPC-SC.src7.IT  	 -codec=3 -seed=1 -tot_src=7  -tot_rep=23)
do_test(LDPC-SC.src8.IT  	 -codec=3 -seed=1 -tot_src=8  -tot_rep=23)
do_test(LDPC-SC.src9.IT  	 -codec=3 -seed=1 -tot_src=9  -tot_rep=23)
do_test(LDPC-SC.src10.IT 	 -codec=3 -seed=1 -tot_src=10 -tot_rep=23)
do_test(LDPC-SC.src11.IT 	 -codec=3 -seed=1 -tot_src=11 -tot_rep=23)
do_test(LDPC-SC.src12.IT 	 -codec=3 -seed=1 -tot_src=12 -tot_rep=23)
do_test(LDPC-SC.src13.IT 	 -codec=3 -seed=1 -tot_src=13 -tot_rep=23)
do_test(LDPC-SC.src14.IT 	 -codec=3 -seed=1 -tot_src=14 -tot_rep=23)
do_test(LDPC-SC.src15.IT 	 -codec=3 -seed=1 -tot_src=15 -tot_rep=23)
do_test(LDPC-SC.src16.IT 	 -codec=3 -seed=1 -tot_src=16 -tot_rep=23)
do_test(LDPC-SC.src17.IT 	 -codec=3 -seed=1 -tot_src=17 -tot_rep=23)
do_test(LDPC-SC.src18.IT 	 -codec=3 -seed=1 -tot_src=18 -tot_rep=23)
do_test(LDPC-SC.src19.IT 	 -codec=3 -seed=1 -tot_src=19 -tot_rep=23)
do_test(LDPC-SC.src20.IT 	 -codec=3 -seed=1 -tot_src=20 -tot_rep=23)
do_test(LDPC-SC.src21.IT 	 -codec=3 -seed=1 -tot_src=21 -tot_rep=23)
do_test(LDPC-SC.src22.IT 	 -codec=3 -seed=1 -tot_src=22 -tot_rep=23)
do_test(LDPC-SC.src23.IT 	 -codec=3 -seed=1 -tot_src=23 -tot_rep=23)
do_test(LDPC-SC.src24.IT 	 -codec=3 -seed=1 -tot_src=24 -tot_rep=23)
do_test(LDPC-SC.src25.IT 	 -codec=3 -seed=1 -tot_src=25 -tot_rep=23)
do_test(LDPC-SC.src26.IT 	 -codec=3 -seed=1 -tot_src=26 -tot_rep=23)
do_test(LDPC-SC.src27.IT 	 -codec=3 -seed=1 -tot_src=27 -tot_rep=23)
do_test(LDPC-SC.src28.IT 	 -codec=3 -seed=1 -tot_src=28 -tot_rep=23)
do_test(LDPC-SC.src29.IT 	 -codec=3 -seed=1 -tot_src=29 -tot_rep=23)
do_test(LDPC-SC.src30.IT 	 -codec=3 -seed=1 -tot_src=30 -tot_rep=23)
do_test(LDPC-SC.src31.IT 	 -codec=3 -seed=1 -tot_src=31 -tot_rep=23)
do_test(LDPC-SC.src32.IT 	 -codec=3 -seed=1 -tot_src=32 -tot_rep=23)
do_test(LDPC-SC.src33.IT 	 -codec=3 -seed=1 -tot_src=33 -tot_rep=23)
do_test(LDPC-SC.src34.IT 	 -codec=3 -seed=1 -tot_src=34 -tot_rep=23)
do_test(LDPC-SC.src35.IT 	 -codec=3 -seed=1 -tot_src=35 -tot_rep=23)
do_test(LDPC-SC.src36.IT 	 -codec=3 -seed=1 -tot_src=36 -tot_rep=23)
do_test(LDPC-SC.src37.IT 	 -codec=3 -seed=1 -tot_src=37 -tot_rep=23)
do_test(LDPC-SC.src38.IT 	 -codec=3 -seed=1 -tot_src=38 -tot_rep=23)
do_test(LDPC-SC.src39.IT 	 -codec=3 -seed=1 -tot_src=39 -tot_rep=23)
do_test(LDPC-SC.src40.IT 	 -codec=3 -seed=1 -tot_src=40 -tot_rep=23)

# ML decoding tests
# we set the -find_min.MLerhead flag to force ML decoding
#
do_test(LDPC-SC.cr2.3.small.ML   	 -codec=3 -seed=1 -find_min_overhead -tot_src=100 -tot_rep=50)
do_test(LDPC-SC.cr1.2.small.ML   	 -codec=3 -seed=1 -find_min_overhead -tot_src=100 -tot_rep=100)
do_test(LDPC-SC.cr1.3.small.ML   	 -codec=3 -seed=1 -find_min_overhead -tot_src=100 -tot_rep=200)
do_test(LDPC-SC.cr1.4.small.ML   	 -codec=3 -seed=1 -find_min_overhead -tot_src=100 -tot_rep=300)
do_test(LDPC-SC.cr1.5.small.ML   	 -codec=3 -seed=1 -find_min_overhead -tot_src=100 -tot_rep=400)

do_test(LDPC-SC.cr3.4.med.ML   	 -codec=3 -seed=1 -find_min_overhead -tot_src=1000 -tot_rep=500)
do_test(LDPC-SC.cr1.2.med.ML   	 -codec=3 -seed=1 -find_min_overhead -tot_src=1000 -tot_rep=1000)
do_test(LDPC-SC.cr1.3.med.ML   	 -codec=3 -seed=1 -find_min_overhead -tot_src=1000 -tot_rep=2000)

do_test(LDPC-SC.src1.ML  	 -codec=3 -seed=1 -find_min_overhead -tot_src=1  -tot_rep=23)
do_test(LDPC-SC.src2.ML  	 -codec=3 -seed=1 -find_min_overhead -tot_src=2  -tot_rep=23)
do_test(LDPC-SC.src3.ML  	 -codec=3 -seed=1 -find_min_overhead -tot_src=3  -tot_rep=23)
do_test(LDPC-SC.src4.ML  	 -codec=3 -seed=1 -find_min_overhead -tot_src=4  -tot_rep=23)
do_test(LDPC-SC.src5.ML  	 -codec=3 -seed=1 -find_min_overhead -tot_src=5  -tot_rep=23)
do_test(LDPC-SC.src6.ML  	 -codec=3 -seed=1 -find_min_overhead -tot_src=6  -tot_rep=23)
do_test(LDPC-SC.src7.ML  	 -codec=3 -seed=1 -find_min_overhead -tot_src=7  -tot_rep=23)
do_test(LDPC-SC.src8.ML  	 -codec=3 -seed=1 -find_min_overhead -tot_src=8  -tot_rep=23)
do_test(LDPC-SC.src9.ML  	 -codec=3 -seed=1 -find_min_overhead -tot_src=9  -tot_rep=23)
do_test(LDPC-SC.src10.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=10 -tot_rep=23)
do_test(LDPC-SC.src11.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=11 -tot_rep=23)
do_test(LDPC-SC.src12.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=12 -tot_rep=23)
do_test(LDPC-SC.src13.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=13 -tot_rep=23)
do_test(LDPC-SC.src14.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=14 -tot_rep=23)
do_test(LDPC-SC.src15.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=15 -tot_rep=23)
do_test(LDPC-SC.src16.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=16 -tot_rep=23)
do_test(LDPC-SC.src17.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=17 -tot_rep=23)
do_test(LDPC-SC.src18.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=18 -tot_rep=23)
do_test(LDPC-SC.src19.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=19 -tot_rep=23)
do_test(LDPC-SC.src20.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=20 -tot_rep=23)
do_test(LDPC-SC.src21.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=21 -tot_rep=23)
do_test(LDPC-SC.src22.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=22 -tot_rep=23)
do_test(LDPC-SC.src23.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=23 -tot_rep=23)
do_test(LDPC-SC.src24.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=24 -tot_rep=23)
do_test(LDPC-SC.src25.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=25 -tot_rep=23)
do_test(LDPC-SC.src26.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=26 -tot_rep=23)
do_test(LDPC-SC.src27.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=27 -tot_rep=23)
do_test(LDPC-SC.src28.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=28 -tot_rep=23)
do_test(LDPC-SC.src29.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=29 -tot_rep=23)
do_test(LDPC-SC.src30.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=30 -tot_rep=23)
do_test(LDPC-SC.src31.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=31 -tot_rep=23)
do_test(LDPC-SC.src32.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=32 -tot_rep=23)
do_test(LDPC-SC.src33.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=33 -tot_rep=23)
do_test(LDPC-SC.src34.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=34 -tot_rep=23)
do_test(LDPC-SC.src35.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=35 -tot_rep=23)
do_test(LDPC-SC.src36.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=36 -tot_rep=23)
do_test(LDPC-SC.src37.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=37 -tot_rep=23)
do_test(LDPC-SC.src38.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=38 -tot_rep=23)
do_test(LDPC-SC.src39.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=39 -tot_rep=23)
do_test(LDPC-SC.src40.ML 	 -codec=3 -seed=1 -find_min_overhead -tot_src=40 -tot_rep=23)

# Test with big objects and various code rates, using IT decoding
#
do_test(LDPC-SC.cr2.3.big.IT   	 -codec=3 -seed=1 -tot_src=10000 -tot_rep=5000)
do_test(LDPC-SC.cr1.2.big.IT   	 -codec=3 -seed=1 -tot_src=10000 -tot_rep=10000)
do_test(LDPC-SC.cr1.3.big.IT   	 -codec=3 -seed=1 -tot_src=10000 -tot_rep=20000)
#do_test(LDPC-SC.cr1.4.big.IT   	 -codec=3 -seed=1 -tot_src=10000 -tot_rep=30000)

# Test with big objects and various code rates, using ML decoding
#
do_test(LDPC-SC.cr2.3.big.ML   	 -codec=3 -seed=1 -tot_src=10000 -tot_rep=5000 -find_min_overhead)
#do_test(LDPC-SC.cr1.2.big.ML   	 -codec=3 -seed=1 -tot_src=10000 -tot_rep=10000 -find_min_overhead)
#do_test(LDPC-SC.cr1.3.big.ML   	 -codec=3 -seed=1 -tot_src=10000 -tot_rep=20000 -find_min_overhead)
#do_test(LDPC-SC.cr1.4.big.ML   	 -codec=3 -seed=1 -tot_src=10000 -tot_rep=30000 -find_min_overhead)

# symbol size tests: the codec must be able to accomodate any symbol size
#
do_test(LDPC-SC.ss1 	 -codec=3 -seed=1 -tot_src=100 -tot_rep=100 -symb_sz=1)
do_test(LDPC-SC.ss2 	 -codec=3 -seed=1 -tot_src=100 -tot_rep=100 -symb_sz=2)
do_test(LDPC-SC.ss3 	 -codec=3 -seed=1 -tot_src=100 -tot_rep=100 -symb_sz=3)

=== tools/descr_stats_v1.2/CMakeLists.txt ===
file (GLOB descr_stat_sources ./descr_stats.c)

set(EXECUTABLE_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/perf_eval)
add_executable(descr_stats  ${descr_stat_sources})

target_link_libraries( descr_stats  m)

=== applis/howto_examples/simple_client_server/CMakeLists.txt ===
file (GLOB simple_server_sources ./simple_server.c)

set(SIMPLE_SERVER_BIN ${EXECUTABLE_OUTPUT_PATH}/simple_server CACHE STRING "simple_server exe")
add_executable(simple_server ${simple_server_sources})

target_link_libraries(simple_server openfec m)


file (GLOB simple_client_sources ./simple_client.c)

set(SIMPLE_SERVER_BIN ${EXECUTABLE_OUTPUT_PATH}/simple_client CACHE STRING "simple_client exe")
add_executable(simple_client ${simple_client_sources})

target_link_libraries(simple_client openfec m)

if(INSTALL_DEVTOOLS)
  install(TARGETS simple_server simple_client
    RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
    COMPONENT applis)
endif()

=== debian/changelog ===
openfec (1.4.2.9+dfsg-2~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 02 Feb 2024 12:09:21 -0800

openfec (1.4.2.9+dfsg-2) unstable; urgency=medium

  * Upload to unstable

 -- Dylan Aïssi <daissi@debian.org>  Sat, 13 Jan 2024 08:42:14 +0100

openfec (1.4.2.9+dfsg-1) experimental; urgency=medium

  * Initial release (Closes: #1002724)
  * Add clarification from the LDPC's author about his license.

 -- Dylan Aïssi <daissi@debian.org>  Fri, 15 Dec 2023 21:23:01 +0100

=== debian/control ===
Source: openfec
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Dylan Aïssi <daissi@debian.org>
Build-Depends: cmake, debhelper-compat (= 13)
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/multimedia-team/openfec
Vcs-Git: https://salsa.debian.org/multimedia-team/openfec.git
Homepage: https://github.com/roc-streaming/openfec

Package: libopenfec1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Application-Level Forward Erasure Correction codes (shared library)
 Application-Level Forward Erasure Correction codes, or AL-FEC (also called
 UL-FEC, for Upper-Layers FEC). The idea is to add redundancy in order to be
 able to recover from erasures. Because of their position in the communication
 stack, these codes are implemented as software codecs, and they find many
 applications in robust transmission and distrituted storage systems.
 .
 This package provides the shared library.

Package: libopenfec-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libopenfec1 (= ${binary:Version}), ${misc:Depends}
Description: Application-Level Forward Erasure Correction codes (development files)
 Application-Level Forward Erasure Correction codes, or AL-FEC (also called
 UL-FEC, for Upper-Layers FEC). The idea is to add redundancy in order to be
 able to recover from erasures. Because of their position in the communication
 stack, these codes are implemented as software codecs, and they find many
 applications in robust transmission and distrituted storage systems.
 .
 This package provides the development files for libopenfec.

## openfec 1.4.2.10+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,11 @@
 if(CMAKE_MAJOR_VERSION LESS 3)
   cmake_minimum_required(VERSION 2.6)
 else()
-  cmake_minimum_required(VERSION 2.8.12)
+  if(CMAKE_MINOR_VERSION LESS 6)
+    cmake_minimum_required(VERSION 2.8.12)
+  else()
+    cmake_minimum_required(VERSION 3.6)
+  endif()
 endif()
 
 ##project

=== debian/changelog ===
openfec (1.4.2.10+dfsg-1) unstable; urgency=medium

  * New upstream version 1.4.2.10+dfsg
  * Standards-Version: 4.7.0 (no changes required)
  * Add debian/upstream/metadata
  * Update Forwarded field for Fix_install_pkgconfig.patch

 -- Dylan Aïssi <daissi@debian.org>  Thu, 08 Aug 2024 09:28:42 +0200

## openfec 1.4.2.11+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -47,7 +47,7 @@
 
 endif (DEBUG STREQUAL "ON")
 
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC -Wno-unused-result")
 
 set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/bin/${CMAKE_BUILD_TYPE}
   CACHE STRING "output path for libraries")

=== debian/changelog ===
openfec (1.4.2.11+dfsg-1) unstable; urgency=medium

  * New upstream version 1.4.2.11+dfsg
  * Drop patch included in upstream release

 -- Dylan Aïssi <daissi@debian.org>  Sun, 13 Oct 2024 14:19:14 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: openfec
 Section: libs
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: Dylan Aïssi <daissi@debian.org>
-Build-Depends: cmake, debhelper-compat (= 13)
-Standards-Version: 4.6.2
+Build-Depends: debhelper-compat (= 13),
+               cmake
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/multimedia-team/openfec
 Vcs-Git: https://salsa.debian.org/multimedia-team/openfec.git
@@ -14,7 +14,8 @@
 Package: libopenfec1
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Description: Application-Level Forward Erasure Correction codes (shared library)
  Application-Level Forward Erasure Correction codes, or AL-FEC (also called
  UL-FEC, for Upper-Layers FEC). The idea is to add redundancy in order to be
@@ -28,7 +29,8 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libopenfec1 (= ${binary:Version}), ${misc:Depends}
+Depends: ${misc:Depends},
+         libopenfec1 (= ${binary:Version}),
 Description: Application-Level Forward Erasure Correction codes (development files)
  Application-Level Forward Erasure Correction codes, or AL-FEC (also called
  UL-FEC, for Upper-Layers FEC). The idea is to add redundancy in order to be

=== debian/watch ===
version=4
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,\
  filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/openfec-$1\.tar\.gz/" \
  https://github.com/roc-streaming/openfec/tags .*/v?(\d\S+)\.tar\.gz

## openfec 1.4.2.12+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,12 @@
 if(CMAKE_MAJOR_VERSION LESS 3)
   cmake_minimum_required(VERSION 2.6)
 else()
-  if(CMAKE_MINOR_VERSION LESS 6)
-    cmake_minimum_required(VERSION 2.8.12)
+  if(CMAKE_MAJOR_VERSION EQUAL 3 AND CMAKE_MINOR_VERSION LESS 6)
+    cmake_minimum_required(VERSION 2.8)
+  elseif(CMAKE_MAJOR_VERSION EQUAL 3 AND CMAKE_MINOR_VERSION LESS 10)
+    cmake_minimum_required(VERSION 3.6)
   else()
-    cmake_minimum_required(VERSION 3.6)
+    cmake_minimum_required(VERSION 3.10)
   endif()
 endif()

=== pc/CMakeLists.txt ===
--- 
+++ 
@@ -17,4 +17,4 @@
 
 install(
     FILES "${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.pc"
-    DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/pkgconfig)
+    DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,15 @@
-file (GLOB_RECURSE openfec_sources *)
+file(GLOB_RECURSE openfec_sources *)
+
+option(OF_USE_REED_SOLOMON_CODEC "Enable Reed-Solomon 2_8 codec" ON)
+option(OF_USE_REED_SOLOMON_2_M_CODEC "Enable Reed-Solomon 2_M codec" ON)
+option(OF_USE_LDPC_STAIRCASE_CODEC "Enable LDPC-Staircase codec" ON)
+option(OF_USE_2D_PARITY_MATRIX_CODEC "Enable 2d parity matrix codec" ON)
+option(OF_USE_LDPC_FROM_FILE_CODEC "Enable ldpc_from_file codec" OFF)
+
+option(ASSEMBLY_SSE_OPT "Enable SSE optimizations for XOR operations" OFF)
+
+configure_file(lib_common/of_build_config.h.in
+  ${CMAKE_CURRENT_SOURCE_DIR}/lib_common/of_build_config.h)
 
 # Use -DBUILD_STATIC_LIBS=ON to build static libraries instead of shared.
 option(BUILD_STATIC_LIBS "Build the static library" OFF)
@@ -10,14 +21,14 @@
 endif(BUILD_STATIC_LIBS)
 
 # From: $cmake --help-property SOVERSION
-#		For shared libraries VERSION and SOVERSION can be used to specify
-#		the build version and api version respectively.
+#    For shared libraries VERSION and SOVERSION can be used to specify
+#    the build version and api version respectively.
 #
 # Edit it as appropriate to be in line with the src/lib_common/of_openfec_api.c::more_about() version
 #
 set_target_properties(openfec PROPERTIES
-			VERSION 1.4.2
-			SOVERSION 1) 
+  VERSION 1.4.2
+  SOVERSION 1)
 
 # Feel free to edit as appropriate the "target_link_libraries".
 #
@@ -40,7 +51,7 @@
 install(
     DIRECTORY ${PROJECT_SOURCE_DIR}/src/
     DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/openfec
-    FILES_MATCHING PATTERN "*.h*")
+    FILES_MATCHING PATTERN "*.h")
 
 include(TestBigEndian)
 test_big_endian(BIG_ENDIAN)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,7 @@
 #
 # PART 1: LDPC-Staircase tests
 #
+if(OF_USE_LDPC_STAIRCASE_CODEC)
 
 # Robustness in front of many transmission types
 #

=== applis/eperftool/CMakeLists.txt ===
file (GLOB eperftool_sources ./*)

set(EPERFTOOL_BIN ${EXECUTABLE_OUTPUT_PATH}/eperftool CACHE STRING "eperftool exe")
add_executable( eperftool ${eperftool_sources})


target_link_libraries( eperftool openfec m)

if(INSTALL_DEVTOOLS)
  install(TARGETS eperftool
    RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
    COMPONENT devtools)
endif()

=== applis/howto_examples/simple_client_server/CMakeLists.txt ===
if(OF_USE_REED_SOLOMON_2_M_CODEC AND OF_USE_LDPC_STAIRCASE_CODEC)
  # simple_server
  file (GLOB simple_server_sources ./simple_server.c)

  set(SIMPLE_SERVER_BIN ${EXECUTABLE_OUTPUT_PATH}/simple_server CACHE STRING "simple_server exe")
  add_executable(simple_server ${simple_server_sources})

  target_link_libraries(simple_server openfec m)

  # simple_client
  file (GLOB simple_client_sources ./simple_client.c)

  set(SIMPLE_SERVER_BIN ${EXECUTABLE_OUTPUT_PATH}/simple_client CACHE STRING "simple_client exe")
  add_executable(simple_client ${simple_client_sources})

  target_link_libraries(simple_client openfec m)

  # install
  if(INSTALL_DEVTOOLS)
    install(TARGETS simple_server simple_client
      RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
      COMPONENT applis)
  endif()
endif(OF_USE_REED_SOLOMON_2_M_CODEC AND OF_USE_LDPC_STAIRCASE_CODEC)

=== debian/changelog ===
openfec (1.4.2.12+dfsg-1) unstable; urgency=medium

  * New upstream version 1.4.2.12+dfsg
  * Update debian/copyright
  * Standards-Version: 4.7.2 (no changes required)

 -- Dylan Aïssi <daissi@debian.org>  Tue, 12 Aug 2025 09:37:33 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Dylan Aïssi <daissi@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cmake
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/multimedia-team/openfec
 Vcs-Git: https://salsa.debian.org/multimedia-team/openfec.git
